"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseProviders;

var _merge = require("../../lib/merge");

function parseProviders({
  providers = [],
  baseUrl,
  basePath
}) {
  const base = `${baseUrl}${basePath}`;
  return providers.map(({
    options,
    ...defaultOptions
  }) => (0, _merge.merge)(defaultOptions, {
    signinUrl: `${base}/signin/${defaultOptions.id}`,
    callbackUrl: `${base}/callback/${defaultOptions.id}`,
    ...options
  }));
}